	device zxspectrum128
        ORG #0100
begin

;memory structure SCREEN 3 (Basic mode):
;+0
;
;00 08 16
;01 09 ..
;02 ..
;03
;04
;05
;06
;07 15 .. .. 255
;+256
;same, 6 pages

;https://www.msx.org/forum/msx-talk/development/initial-colors-and-screen-mode-startup
;SCREEN 3 (4x4 pixel blocks/Multicolour mode):
;?
;Charcter colour patterns        0000-05FF
;Name table (char positions)     0800-0AFF
;Sprite attribute table          1B00-1B7F       (See note C)
;Sprite character patterns       3800-3FFF       (See note D)
;------------------------------------------------------------------
;| Palette |    Colour	  | Brightness | Brightness | Brightness |
;| number  |		  |  of red    |   of blue  |  of green  |
;|---------+---------------+------------+------------+------------|
;|    0	  | transparent   |	0      |     0	    |	  0	 |
;|    1	  | black	  |	0      |     0	    |	  0	 |
;|    2	  | bright green  |	1      |     1	    |	  6	 |
;|    3	  | light green   |	3      |     3	    |	  7	 |
;|    4	  | deep blue	  |	1      |     7	    |	  1	 |
;|    5	  | bright blue   |	2      |     7	    |	  3	 |
;|    6	  | deep red	  |	5      |     1	    |	  1	 |
;|    7	  | light blue	  |	2      |     7	    |	  6	 |
;|    8	  | bright red	  |	7      |     1	    |	  1	 |
;|    9	  | light red	  |	7      |     3	    |	  3	 |
;|   10	  | bright yellow |	6      |     1	    |	  6	 |
;|   11	  | pale yellow   |	6      |     3	    |	  6	 |
;|   12	  | deep green	  |	1      |     1	    |	  4	 |
;|   13	  | purple	  |	6      |     5	    |	  2	 |
;|   14	  | grey	  |	5      |     5	    |	  5	 |
;|   15	  | white	  |	7      |     7	    |	  7	 |
;------------------------------------------------------------------

	xor a
	ld      (0F3EAh), a	; BAKCLR  #F3EA   1       Background color
	ld      (0F3EBh), a	; BDRCLR  #F3EB   1       Border color

	ld      a, 3            ; CHGMOD
							; Address  : #005F
							; Function : Switches to given screenmode
							; Input    : A  - screen mode
							; Registers: All
	call setmode

;;generate pal
	ld      hl, $300
	push hl
	xor a
gen_pal:
	push af
	rra
;0rrr.0bbb,0000.0ggg
	ld (hl),0;a
	inc hl
	ld (hl),a;c
	inc hl
	pop af
	inc a
	cp 16
	jr nz, gen_pal

	di
	xor     a
	out     (99h), a
	ld      a, 90h ;16+128
	out     (99h), a
	pop hl
	push hl
	ld      bc, 209Ah
	otir

	pop hl
;	ld hl,$0300
	
	ld de,$0301,b,$40,(hl),l:ldir

;generate LUT table for plot
lut_tab equ $2000
pixa	equ $0F00
	ld de,pixa;$F00
	ld l,e
;B=0
lut_lp:
	ld h,lut_tab/256
	ld (hl),d
	inc h
	ld (hl),e
	inc h
	ld (hl),b;X
	inc l
	inc de
	ld a,l
	and 7
	jr nz,no_disp_x
	inc d
	ld e,a;A=0
no_disp_x:
;	and 1
;	jr nz,next_x
	rra
	jr c,next_x

	ld a,b
	add a,8
	ld b,a
next_x:
	bit 6,l
	jr z,lut_lp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mainloop:
	ei
	halt		; Wait for vertical blank
	di

xy1:ld de,0 ;Y1.X1
;dxy1:ld bc,$0202;dy1.sx1
dxy1:ld bc,$0101;dy1.sx1

	call move
	call move
	ld (xy1+1),de
	ld (dxy1+1),bc

xy2:ld de,$2F37 ;Y2.X2
;dxy2:ld bc,$0000;dy2.sx2
dxy2:ld bc,$ffff;dy2.sx2

	call move
	ld (xy2+1),de
	ld (dxy2+1),bc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;http://www.msxcomputermagazine.nl/mccm/millennium/milc/vdp/topic_8.htm
;Ex1: Write 255 bytes from RAM to VRAM
;256 bytes exactly, B=0
;;	LD HL,#0000
;;	LD A,L
	xor a
	OUT (#99),A
;	LD A,H
	OR #40
	OUT (#99),A
	LD HL,pixa;#0F00
	push hl
	ld a,6;copy 6x256 bytes
oo:
	ld bc,$0098
	OTIR
	dec a
	jr nz,oo
;;;;;;;; reset data ;;;;;;;;;;;;;
	pop hl
	push hl
res_lp:
	ld a,(hl)
	ld c,a
	and $0F
	jr z,no_dec_r
	dec c
no_dec_r:
	ld a,c
	and $F0
	jr z,no_dec_l
	ld a,c
	sub $10
	ld c,a
no_dec_l:
	ld (hl),c
	inc hl
	ld a,h
	cp 6+pixa/256
	jr nz,res_lp

	pop hl

;add some noise
	ld a,r
	add a,l
	ld l,a
	add a,a
	add a,l
	ld l,a
;	cpl
;	ld r,a
	and 7
	add a,h
	ld h,a
	ld (hl),l

	in	a,(0aah) ; Check whether space is pressed
	and	0f0h
	or	8
	out	(0aah),a
	in	a,(0a9h)
	and	1
;	jr	z,exiti;mainloop ; Not pressed, keep on keeping on
	jr	nz,mainloop ; Not pressed, keep on keeping on
exiti:
; A=0
setmode:
	rst     30h
	db  80h
	dw 5Fh
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
move:
;x1+dx1
	ld a,c
;	dec a
	add a,e
	ld e,a
	jr z,ch_dx
	cp 63
	jr nz,skip_x
ch_dx:
	ld a,c
	neg;xor 2
	ld c,a
skip_x:

;y1+dy1
	ld a,b
	;dec a
	add a,d
	ld d,a
	jr z,ch_dy
	cp 47
	jr nz,skip_y
ch_dy:
	ld a,b
	neg;xor 2
	ld b,a
skip_y:
;	ret
	push de
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
plot: ; D.E=y.x
	ld h,lut_tab/256
	ld l,d
	
	ld d,(hl)
	inc h
	ld a,(hl)
	inc h ;Y done
	ld l,e
	add a,(hl)
;	ld l,e
	ld e,a
	ld a,$F0
	bit 0,l
	jr z,no_inv
	cpl
no_inv:
	ex de,hl
	or (hl)
	ld (hl),a
	pop de
	ret
end
	display /d,end-begin
	savebin "..\m3.com",begin,end-begin

